<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateEmailTemplatesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('email_templates', function (Blueprint $table) {
            $table->increments('id');
            $table->timestamps();

            $table->string('name', 127);
            $table->string('description', 255);

            $table->string('from', 255);
            $table->string('to', 255);
            $table->string('subject', 255);
            $table->text('body');

            $locales = ['en'];
            foreach ($locales as $locale) {
                $table->string('subject_' . $locale, 255);
                $table->text('body_' . $locale);
            }

            $table->boolean('layout')->default(false);
            $table->boolean('html')->default(false);

            $table->boolean('to_admin')->default(false);
            $table->boolean('to_d_admin')->default(false);

            $table->unique('name', 'name_unique');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('email_templates');
    }
}
