<?php

namespace AltSolution\Admin\EmailTemplate;

use Illuminate\Support\Str;

class TemplateRepository
{
    /** @var TemplateInterface[] $templates */
    protected $templates;

    public function __construct()
    {
        $this->templates = app()->tagged('admin.email-template');
    }

    function findAll()
    {
        return $this->templates;
    }

    function findByName($name)
    {
        foreach ($this->templates as $template) {
            if ($template->getName() == Str::studly($name)) {
                return $template;
            }
        }

        return null;
    }
}
