<?php

namespace AltSolution\Admin\Form\Field;

use AltSolution\Admin\Form\AbstractField;
use AltSolution\Admin\Image\ImagesInterface;
use Illuminate\Support\Arr;

class Image extends AbstractField
{
    protected $view = 'image';
    protected $rules = ['image'];

    protected function customViewData()
    {
        $empty = $this->normalizeBoolean($this->getOption('empty', true));

        $image = null;
        $name_delete = null;
        if ($this->getValue()) {
            $size = $this->getOption('image_size', 'list');
            $dataSource = $this->getForm()->getData();
            if (strpos($this->name, '.') === false) {
                if (!$dataSource instanceof ImagesInterface) {
                    throw new \Exception('Data source not implements ImagesInterface');
                }
                $image = $dataSource->imageUrl($this->name, $size);
            } else {
                $pos = strrpos($this->name, '.');
                $ns = substr($this->name, 0, $pos);
                $name = substr($this->name, $pos + 1);

                $ds = Arr::get($dataSource, $ns);
                if (!$ds instanceof ImagesInterface) {
                    throw new \Exception('Data source not implements ImagesInterface');
                }
                $image = $ds->imageUrl($name, $size);
            }

            $name_delete = $this->transformName($this->name . '_delete');
        }

        return compact('empty', 'image', 'name_delete');
    }
}