<?php

namespace AltSolution\Admin\Form\Field;

use AltSolution\Admin\Form\AbstractField;
use AltSolution\Admin\Upload\UploadsInterface;
use Illuminate\Support\Arr;

class Upload extends AbstractField
{
    protected $view = 'upload';
    protected $rules = ['file'];

    protected function customViewData()
    {
        $empty = $this->normalizeBoolean($this->getOption('empty', true));
        $filename = $this->getOption('filename');

        $file = null;
        $name_delete = null;
        if ($this->getValue()) {
            $dataSource = $this->getForm()->getData();
            if (strpos($this->name, '.') === false) {
                if (!$dataSource instanceof UploadsInterface) {
                    throw new \Exception('Data source not implements UploadsInterface');
                }
                //$file = $dataSource->uploadUrl($this->name);
                $file = cms_admin_upload_url($dataSource->getUploadsPath(), $dataSource->{$this->name}, $filename);
            } else {
                $pos = strrpos($this->name, '.');
                $ns = substr($this->name, 0, $pos);
                $name = substr($this->name, $pos + 1);

                $ds = Arr::get($dataSource, $ns);
                if (!$ds instanceof UploadsInterface) {
                    throw new \Exception('Data source not implements UploadsInterface');
                }
                //$file = $ds->uploadUrl($name);
                $file = cms_admin_upload_url($ds->getUploadsPath(), $ds->{$name}, $filename);
            }

            $name_delete = $this->transformName($this->name . '_delete');
        }

        return compact('empty', 'file', 'name_delete', 'filename');
    }
}
