<?php

namespace AltSolution\Admin\Models;

use AltSolution\Admin\Locale\TranslateInterface;
use AltSolution\Admin\Locale\TranslateTrait;
use Illuminate\Database\Eloquent\Model;

/**
 * @property int $id
 * @property string $name
 * @property string $description
 * @property string $from
 * @property string $to
 * @property string $subject
 * @property string $body
 * @property bool $layout
 * @property bool $html
 * @property bool $to_admin
 * @property bool $to_d_admin
 */
class EmailTemplate extends Model implements TranslateInterface
{
    use TranslateTrait;

    protected $table = 'email_templates';

    protected $fillable = [
    	'name',
    	'description',

    	'from',
    	'to',
    	'subject',
    	'body',

        'subject_*',
        'body_*',
    ];
}
