<?php

namespace AltSolution\Admin\Modules;

use AltSolution\Admin\Http\Controllers;
use AltSolution\Admin\System\AbstractModule;
use AltSolution\Admin\System\MenuBuilder;
use AltSolution\Admin\System\PermissionBuilder;
use Illuminate\Routing\Router;

class LogModule extends AbstractModule
{
    /**
     * Get menu sections for display in side menu
     * @param MenuBuilder $menu
     */
    public function buildMenu(MenuBuilder $menu)
    {
        //
    }

    /**
     * Build permissions for access control
     * @param PermissionBuilder $builder
     */
    public function buildPermissions(PermissionBuilder $builder)
    {
        $builder->addSection('log', 'admin::log.ps_logs');
        $builder->addPermission('logs', 'admin::log.p_logs');
    }

    public function registerRoutes(Router $router)
    {
        $router->get('logs', [Controllers\LogsController::class, 'index'])->name('logs_list');
        $router->get('logs/{file}/view', [Controllers\LogsController::class, 'view'])->name('logs_view');
        $router->get('logs/{file}/download', [Controllers\LogsController::class, 'download'])->name('logs_dl');
    }
}