<?php

namespace AltSolution\Admin\Modules;

use AltSolution\Admin\Http\Controllers;
use AltSolution\Admin\System\AbstractModule;
use AltSolution\Admin\System\MenuBuilder;
use AltSolution\Admin\System\PermissionBuilder;
use Illuminate\Routing\Router;

class OptionModule extends AbstractModule
{
    public function buildMenu(MenuBuilder $menu)
    {
        $menu->addSection(trans('admin::option.ms_options'), 'fas fa-cogs')
            ->setAlias('options')
            ->setWeight(-100);

        $menu->addItem(trans('admin::option.mi_core'), route('admin::options'))
            ->setPermission('options');
        $menu->addItem(trans('admin::option.mi_seo'), route('admin::seo'))
            ->setPermission('options');
        $menu->addItem(trans('admin::log.ms_logs'), route('admin::logs_list'))
            ->setPermission('logs');
        // TODO:
        $menu->addItem(trans('admin::core.ms_cache'), route('admin::cache'))
            ->setPermission('cache');
    }

    public function buildPermissions(PermissionBuilder $builder)
    {
        $builder->addSection('option', 'admin::option.ps_options');
        $builder->addPermission('options', 'admin::option.p_options');
    }

    public function registerRoutes(Router $router)
    {
        $router->get('options', [Controllers\OptionsController::class, 'getIndex'])->name('options');
        $router->post('options', [Controllers\OptionsController::class, 'postIndex'])->name('options_fulfil');
        $router->get('options/seo', [Controllers\OptionsController::class, 'getSeo'])->name('seo');
        $router->post('options/seo', [Controllers\OptionsController::class, 'postSeo'])->name('seo_fulfil');
    }
}