<?php

namespace AltSolution\Admin\System;

use Illuminate\Contracts\Support\Arrayable;

class BaseLayout implements Arrayable
{
    //protected $components = [];

    /**
     * @var string
     */
    protected $title;
    /**
     * @var Notify
     */
    protected $notify;

    public function __construct()
    {
        $this->notify = new Notify;
    }

    /**
     * @param string $title
     * @return $this
     */
    public function setTitle($title)
    {
        $this->title = $title;

        return $this;
    }

    /**
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * @param string $type
     * @param string $message
     * return $this
     * @throws \Exception
     */
    public function addNotify($type, $message)
    {
        $this->notify->add($type, $message);
    }

    /**
     * @return Notify
     */
    public function getNotifications()
    {
        return $this->notify;
    }

    public function toArray()
    {
        return [
            'title' => $this->title,
            'notify' => $this->notify,
        ];
    }
}
